. $Header: /u/drspeech/repos/quicknet2/qnmungewts.man,v 1.5 2014/02/18 20:42:06
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.TH qnmungewts 1 "$Date: 2014/02/18 22:45:41 $" ICSI "ICSI SPEECH SOFTWARE"
.SH NAME
qnmungewts \- Convert QuickNet weights files between different MLP sizes and formats
.SH SYNOPSIS
.B qnmungewts
[
.I options
]
.SH DESCRIPTION
.I qnmungewts
is a program for converting the network weights files 
used by 
.MS qnmultitrn 1
and 
.MS qnmultifwd 1
between different formats and net architectures.  It can discard
output layers from weight files, add extra randomly-initialized output
layers and stack the weights from two networks on top of each other to
form a net with more layers.
.SH OPTIONS
.I qnmungewts
can take the following options (defaults in parens):
.TP 1i			\" Indent the paragraph
\fBin1_file\fR=\FIfilename\fR ("")
Input weights file, or
.B -
to use stdin.  If no file is supplied then weights will be randomly
initialized.
.TP
\fBin1_format\fR=\fItype\fR ("matlab")
The format of the first input weights file.  Supported formats are 
"rap3", which is the original ICSI ascii weights file 
format, "tnet" for a TNet-style ASCII weights file
and the default "matlab" which uses matlab level 4 binary format for
storing weights.
.TP
\fBin1_layers\fR=\fIcount\fR ("0")
The numer of layers of the input net to use, starting from the input
layer.  The default, 0, means use all layers from \fBin1_file\fR.
.TP
\fBin2_file\fR=\FIfilename\fR ("")
Second Input weights file to be stacked on weights read from
\fBin1_file\fR.  Specify 
.B -
to use stdin. 
.TP
\fBin2_format\fR=\fItype\fR ("matlab")
The format of the second input weights file.  Supported formats are 
"rap3", which is the original ICSI ascii weights file 
format, "tnet" for a TNet-style ASCII weights file
and the default "matlab" which uses matlab level 4 binary format for storing
weights.
.P
.PD 0
.BI init_random_bias_min= float[,float][,float...]
.P
.BI init_random_bias_max= float[,float][,float...]
.P
.BI init_random_weight_min= float[,float][,float...]
.TP
.PD 1
.BI init_random_weight_max= float,[float][,float...]
Limits for the random initialization of weights and biases \- only
used for sections of the net for which no data is read from the input
files.  If one value
supplied, applies to all weights/biases.  If two values supplied,
second applies to the output layer and the first to the rest of the
layers.  If more than two values
are supplied, there must be one fewer values than the number of layers
(due to the input layer not having biases or weights).  In this case, values
apply to layers in order of input through output.
.TP
.BI init_random_seed= integer
Set the seed for random number generation used for
initialization of weights.
.TP
.BI out_size= integer,integer[,...] ("")
Specify the size of the MLP layers in the output net, starting with
the number of units in the input layer. The number of integers implies the number of layers, which can
be between 2 and 9.  If no \fBout_size\fR is specified then it is
deduced from the input weigth files.
.TP
.BI out_file= filename
Name for the output weights file to be written to.  If this is not
specified then no output weight file will be produced.
.TP
\fBout_format\fR=\fItype\fR ("matlab")
The format in which the output weights file will be written.  
Options include "rap3" which is the original ICSI ascii weights 
file format, (as described in 
.MS weights 5 ), "tnet" for a TNet-style ASCII weights file
and the default "matlab", matlab level 4 binary format.  Note that the
matlab format stores weights as floats although they are read into
double matrices in matlab.
.TP
\fBout_output_type\fR=\fItype\fR ("softmax")
Specify the type of non-linearity to store in the weights file for the
output layer. 
Allowable values are \fBlinear\fR, \fBsigmoid\fR, \fBtanh\fR and \fBsoftmax\fR
(the default).   Note that non-output layers are all \fBsigmoid\fR.
.TP
.BI log_file= filename
The file in which to log status messages.  Specifying a
filename of
.B \-
sends the results to standard output.
.TP
.BI debug= integer
Set the level of debugging output.  \fB0\fR means none, \fB6\fR means lots!
.TP
.BI verbose= bool
Output status messages if
.BR true .
(which is the default).
.SH EXAMPLE
To convert a tnet weights file into
format,
.EX
qnmungewts \\
  in1_file=simplebn/boot-plp12N-16k-70h-aI5+117i+2000h+54o.tnet \\
  in1_format=tnet \\
  out_format=maltab out_file=plp12N-117+2000h+54o.mat
.SH NOTES
Based on qncopywts by Dan Ellis.
.SH AUTHOR
David Johnson  <davidj@ICSI.Berkeley.EDU>
.SH SEE ALSO
.MS qnstrn 1 ,
.MS qnsfwd 1  ,
.MS weights 5 ,
.MS MLPW 5 .

